



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>计算几何----判断空间点是否在一个四面体(tetrahedron）内部</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">计算几何----判断空间点是否在一个四面体(tetrahedron）内部</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 03:36:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>DESCRIPTION：</p>
<p>判断空间点 P(x, y, z)是否在一个四面体的内部？</p>
<p>Let the tetrahedron have vertices</p>
<pre class="prettyprint linenums">        V1 = (x1, y1, z1)<br />
        V2 = (x2, y2, z2)<br />
        V3 = (x3, y3, z3)<br />
        V4 = (x4, y4, z4)
</pre>
<p>and your test point be</p>
<pre class="prettyprint linenums">        P = (x, y, z).
</pre>
<p>Then the point P is in the tetrahedron if following fivedeterminants all have the same sign.</p>
<pre class="prettyprint linenums">             |x1 y1 z1 1|<br />
        D0 = |x2 y2 z2 1|<br />
             |x3 y3 z3 1|<br />
             |x4 y4 z4 1|

             |x  y  z  1|<br />
        D1 = |x2 y2 z2 1|<br />
             |x3 y3 z3 1|<br />
             |x4 y4 z4 1|

             |x1 y1 z1 1|<br />
        D2 = |x  y  z  1|<br />
             |x3 y3 z3 1|<br />
             |x4 y4 z4 1|

             |x1 y1 z1 1|<br />
        D3 = |x2 y2 z2 1|<br />
             |x  y  z  1|<br />
             |x4 y4 z4 1|

             |x1 y1 z1 1|<br />
        D4 = |x2 y2 z2 1|<br />
             |x3 y3 z3 1|<br />
             |x  y  z  1|
</pre>
<p>简单地对上面的算法进行分析:</p>
<p>其实上述算法的核心思想是 四面体的体积 = 4个小四面体的之和（判断点 与 四面体的四个面各自组成的 小四面体）</p>
<p>但是注意： 一个四面体的体积可有上述的行列式计算， 但是行列式的&#20540;可能是负的，只有保证点的顺序是左手法则是才能保证是正的。</p>
<pre class="prettyprint linenums">// copyright @ L.J.SHOU Dec.18, 2013<br />
// test whether a point is in a tet<br />
#include &quot;include/cmatrix&quot;<br />
#include &quot;pt.h&quot;<br />
#include &lt;cassert&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;iostream&gt;<br />
using namespace std;<br />
typedef techsoft::matrix&lt;double&gt; Matrix;//class for matrix<br />
typedef cpt&lt;double&gt; CPt; //class for points<br />
enum SpaceRelation{ IN, OUT, ONSURFACE};

/*<br />
* tell whether a point is in a tetrahedran or not<br />
* return IN, OUT, ONSURFACE<br />
*/<br />
SpaceRelation TestPointInTet(vector&lt;CPt&gt;&amp; tet, CPt&amp; point)<br />
{<br />
  assert(tet.size() == 4);<br />
  Matrix mat[5];<br />
  for(int i=0; i&lt;5; ++i)<br />
    mat[i].resize(4,4);<br />
  double det[5];

  for(int i=0; i&lt;4; ++i)<br />
  {<br />
    mat[0](i,0) = tet[i].x;<br />
    mat[0](i,1) = tet[i].y;<br />
    mat[0](i,2) = tet[i].z;<br />
    mat[0](i,3) = 1;<br />
  }

  if(mat[0].det() &lt; 0)<br />
  {<br />
    swap(tet[0].x, tet[1].x);<br />
    swap(tet[0].y, tet[1].y);<br />
    swap(tet[0].z, tet[1].z);

    for(int i=0; i&lt;4; ++i)<br />
    {<br />
      mat[0](i,0) = tet[i].x;<br />
      mat[0](i,1) = tet[i].y;<br />
      mat[0](i,2) = tet[i].z;<br />
      mat[0](i,3) = 1;<br />
    }<br />
  }

  mat[1](0,0) = point.x;<br />
  mat[1](0,1) = point.y;<br />
  mat[1](0,2) = point.z;<br />
  mat[1](0,3) = 1;<br />
  for(int i=0; i&lt;4; ++i)<br />
  {<br />
    if(i == 0) continue;<br />
    mat[1](i,0) = tet[i].x;<br />
    mat[1](i,1) = tet[i].y;<br />
    mat[1](i,2) = tet[i].z;<br />
    mat[1](i,3) = 1;<br />
  }

  mat[2](1,0) = point.x;<br />
  mat[2](1,1) = point.y;<br />
  mat[2](1,2) = point.z;<br />
  mat[2](1,3) = 1;<br />
  for(int i=0; i&lt;4; ++i)<br />
  {<br />
    if(i == 1) continue;<br />
    mat[2](i,0) = tet[i].x;<br />
    mat[2](i,1) = tet[i].y;<br />
    mat[2](i,2) = tet[i].z;<br />
    mat[2](i,3) = 1;<br />
  }

  mat[3](2,0) = point.x;<br />
  mat[3](2,1) = point.y;<br />
  mat[3](2,2) = point.z;<br />
  mat[3](2,3) = 1;<br />
  for(int i=0; i&lt;4; ++i)<br />
  {<br />
    if(i == 2) continue;<br />
    mat[3](i,0) = tet[i].x;<br />
    mat[3](i,1) = tet[i].y;<br />
    mat[3](i,2) = tet[i].z;<br />
    mat[3](i,3) = 1;<br />
  }

  mat[4](3,0) = point.x;<br />
  mat[4](3,1) = point.y;<br />
  mat[4](3,2) = point.z;<br />
  mat[4](3,3) = 1;<br />
  for(int i=0; i&lt;4; ++i)<br />
  {<br />
    if(i == 3) continue;<br />
    mat[4](i,0) = tet[i].x;<br />
    mat[4](i,1) = tet[i].y;<br />
    mat[4](i,2) = tet[i].z;<br />
    mat[4](i,3) = 1;<br />
  }

  double volume = 0;<br />
  for(int i=0; i&lt;5; ++i)<br />
  {<br />
	det[i] = mat[i].det();<br />
	//cout &lt;&lt; det[i] &lt;&lt; endl;<br />
  }

  for(int i=1; i&lt;=4; ++i)<br />
    volume += fabs(det[i]);

  if(fabs(det[0]-volume) &lt; 1e-15)<br />
  {<br />
    for(int i=1; i&lt;=4; ++i)<br />
	{<br />
	  if(fabs(det[i]) &lt; 1e-15)<br />
	    return ONSURFACE;<br />
    }<br />
	return IN;<br />
  }<br />
  else<br />
    return OUT;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvr5ry8.html">MySQL数据库7 - 汇总和分组数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2212wq.html">MYSQL权限表user操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4w3v9.html">升级Dell的R810固件版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0we1q.html">android MotionEvent获得当前位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdg7re8.html">Asp登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkvjd8.html">Notepad&plus;&plus;的一些常用的快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xk5e8.html">JSP路径出现故障</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypyxn8.html">&period;NET并行与多线程学习系列一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkj7o8.html">Codevs  4189  字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj10v69.html">KVM设置DHCP、DNS、Gateway</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzewxg8.html">关于MyEclipse 半天打不开的问题（工作区间损坏）--转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwgk69.html">poj1067威佐夫博奕</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jv6do8.html">ArcGIS字段计算器分割字段中的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v2xy9.html">input   type  file兼容性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrw4z9.html">POJ 2711 Leapin&amp;&num;39&semi; Lizards &sol; HDU 2732 Leapin&amp;&num;39&semi; Lizards &sol; BZOJ 1066 &lbrack;SCOI2007&rsqb;蜥蜴（网络流，最大流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2xmzz9.html">map  小模板~~~  写的不好  继续添加</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjw7jj9.html">Python：windows下scikit-learn 安装和更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emerjm9.html">Vultr搭建SS服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk1nz9.html">Alpha 冲刺一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppj0r79.html">循序渐进学&period;Net Core Web Api开发系列【8】：访问数据库&lpar;基本功能&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4yy260q.html">wordpress内存不足问题&OpenCurlyDoubleQuote;Fatal error&colon;out of memoryin etc&period;&period;&period;&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yy55eq.html">MyBatis执行过程显示SQL语句的log4j配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwddmoy8.html">Java 集合系列 15 Map总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmm71z9.html">解决qt5在ubuntu下无法调用fcitx输入中文的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwddgvz8.html">nssm在windows服务器上部署nodejs，coffee启动方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oor739.html">HTML5 视频规范简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvvl1jq.html">SqlHelper帮助类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddzyxq.html">idea tomcat &plus;eclipse式的部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnn1zd8.html">Oracle创建表</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okk77l9.html">hdu 4628 Pieces</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
